
//******************************************************************************
// File Name            : cmd_ctrl.v
//------------------------------------------------------------------------------
// Function             : cmd 
//                        
//------------------------------------------------------------------------------
// Designer             : yokomizo 
//                        yokomizo
//------------------------------------------------------------------------------
// History
// -.-- 2010/8/27
//******************************************************************************
module cmd_ctrl(
RESETB, 
CLK,
TX_DATA,
TX_DATA_EN,
RX_DATA,
RX_DATA_EN,
CMD      
);
//            PIN NAME         description        
input         RESETB;         // power on reset    
input         CLK;         // main clk          
//                                      
output    [7:0]TX_DATA;        //tx data 8bit
output         TX_DATA_EN;         //tx commond
input   [7:0]RX_DATA;        //rx data 8bit
input        RX_DATA_EN;     //rx data enable
output  [15:0] CMD;
   
//
        
parameter       p_bit_end_count    =12'd346; // 115.2Kbps clk=40.0MHz
//parameter     p_bit_end_count    =12'd136; // 460.8Kbps clk=62.5MHz
//   
reg   [7:0]TX_DATA;        //tx data 8bit
reg        TX_DATA_EN;     //tx data enable 
//
//reg        OUT_DATA ;
   
//
   reg [7:0]     rx_data_d1;   
   reg [7:0]     rx_data_d2;   
   reg [7:0]     rx_data_d3;
   reg [7:0]     rx_data_d4;
   reg           rx_data_en_d1;   
   reg [15:0]    rx_cmd;
   reg           rx_cmd_en;
   
   reg [2:0]     msg_cnt;
   reg [2:0]     msg_cnt_end;
   reg [47:0]     msg_data ;
//
//  $B%3%^%s%I<u?.(B
//

//$B<u?.%G!<%?$NJ];}(B
always @(posedge CLK or negedge RESETB) begin
  if (RESETB==1'b0)
    begin
      rx_data_d1 <= 8'h00;
      rx_data_d2 <= 8'h00;
      rx_data_d3 <= 8'h00;
      rx_data_d4 <= 8'h00;
      rx_data_en_d1 <= 1'b0;
    end
  else
    if (RX_DATA_EN==1'b1)
      begin
        rx_data_d1 <= RX_DATA;
        rx_data_d2 <= rx_data_d1;
        rx_data_d3 <= rx_data_d2;
        rx_data_d4 <= rx_data_d3;
        rx_data_en_d1 <= 1'b1;
      end
    else
      begin
        rx_data_d1 <= rx_data_d1;
        rx_data_d2 <= rx_data_d2;
        rx_data_d3 <= rx_data_d3;
        rx_data_d4 <= rx_data_d4;
        rx_data_en_d1 <= 1'b0;
      end
end
   
//LF$B$N8!=P$H%3%^%s%IH/9T(B        
always @(posedge CLK or negedge RESETB) begin
  if (RESETB==1'b0)
    begin
      rx_cmd <= 8'h00;
      rx_cmd_en <= 1'b0; 
    end
  else
    if ((rx_data_en_d1==1'b1)&&(rx_data_d1==8'h0a)) //LF$B$,F~NO(B
      begin
        rx_cmd <= {rx_data_d4,rx_data_d3};//LF$B$N(B2,3$B8DA0$N%G!<%?$r%3%^%s%I$H$7$FJ];}(B
        rx_cmd_en <= 1'b1; //$B%3%^%s%IH/9T(B
      end
    else
      begin
        rx_cmd <= rx_cmd;
        rx_cmd_en <= 1'b0;
      end 
end

assign CMD = rx_cmd;

//$B%a%C%;!<%8$N@8@.(B   
always @(posedge CLK or negedge RESETB) begin
  if (RESETB==1'b0)
    begin
      msg_data <= {"      "};
      msg_cnt_end <= 3'd0; 
    end
  else
    if ((rx_data_en_d1==1'b1)&&(rx_data_d1==8'h0a)) //LF$B$,F~NO(B
      if (rx_data_d4==8'h41) //3$B8DA0$N%G!<%?$,(B 'A'$B$N>l9g(B
        begin
          msg_data <= "on\n   "; //$B%a%C%;!<%8@_Dj(B
          msg_cnt_end <= 3'd3;   //$B%a%C%;!<%8=*N;%?%$%_%s%0;XDj(B
        end
      else if (rx_data_d4==8'h42) //3$B8DA0$N%G!<%?$,(B 'B'$B$N>l9g(B
        begin
          msg_data <= "off\n  "; //$B%a%C%;!<%8@_Dj(B
          msg_cnt_end <= 3'd4;   //$B%a%C%;!<%8=*N;%?%$%_%s%0;XDj(B
        end
      else if (rx_data_d4==8'h43) //3$B8DA0$N%G!<%?$,(B 'C'$B$N>l9g(B
        begin
          msg_data <= {"sel",rx_data_d3,"\n "}; //$B%a%C%;!<%8@_Dj(B
          msg_cnt_end <= 3'd5; 
        end
      else  //3$B8DA0$N%G!<%?$,(B 'a','b','C'$B0J30$N>l9g(B
        begin
          msg_data <= "err\n  "; //$B%a%C%;!<%8@_Dj(B
          msg_cnt_end <= 3'd4;   //$B%a%C%;!<%8=*N;%?%$%_%s%0;XDj(B
        end
    else
      begin
        msg_data <= msg_data ; 
        msg_cnt_end <= msg_cnt_end ; 
      end 
end // always @ (posedge CLK or negedge RESETB)

//$B%a%C%;!<%8@8@.MQ%+%&%s%?(B
always @(posedge CLK or negedge RESETB) begin
  if (RESETB==1'b0)
    msg_cnt <= 3'd0;
  else
    if (rx_cmd_en==1'b1) //$B%3%^%s%IH/9T$G%+%&%s%H3+;O(B
      msg_cnt <= 3'd1;
    else
      if ((msg_cnt==3'd0)|| (msg_cnt==msg_cnt_end))//$B%+%&%s%HDd;_(B
        msg_cnt <= 3'd0;
      else
        msg_cnt <= msg_cnt + 3'd1; //$B%+%&%s%H(B 
end

//$B%a%C%;!<%8%G!<%?Aw?.(B          
always @(posedge CLK or negedge RESETB) begin
  if (RESETB==1'b0)
    TX_DATA <= 8'h00;
  else
    case (msg_cnt)
      3'd0:TX_DATA <= 8'h00;
      3'd1:TX_DATA <= msg_data[47:40];
      3'd2:TX_DATA <= msg_data[39:32];
      3'd3:TX_DATA <= msg_data[31:24];
      3'd4:TX_DATA <= msg_data[23:16];
      3'd5:TX_DATA <= msg_data[15:8];
      3'd6:TX_DATA <= msg_data[7:0];
      default TX_DATA <= 8'h00;
    endcase
end
   
//$B%a%C%;!<%8%G!<%?!&%$%M!<%V%k@8@.(B        
always @(posedge CLK or negedge RESETB) begin
  if (RESETB==1'b0)
      TX_DATA_EN <= 1'b0;
  else
    if (msg_cnt==3'd1) //$B%a%C%;!<%8@8@.%+%&%s%?$N%+%&%s%H3+;O$G%$%M!<%V%k(B
      TX_DATA_EN <= 1'b1;
    else if (msg_cnt==4'd0) //$B%a%C%;!<%8@8@.%+%&%s%?$NDd;_$G%G%#%;!<%V%k(B
      TX_DATA_EN <= 1'b0;
    else
      TX_DATA_EN <= TX_DATA_EN;
end
   
   
assign CMD = rx_cmd;
       
endmodule
