`timescale 1ns / 1ps


module data_path_ap_test;

        // Inputs
        reg RESETB;
        reg CLK;
        reg RXD;

        // Outputs
        wire TXD;
        wire LED_0;
        wire LED_1;
        wire LED_2;
        wire LED_3;
        wire LED_4;
        wire LED_5;

        // Instantiate the Unit Under Test (UUT)
        data_path_ap uut (
                .RESETB(RESETB), 
                .CLK(CLK), 
                .TXD(TXD), 
                .RXD(RXD), 
                .LED_0(LED_0),
                .LED_1(LED_1),
                .LED_2(LED_2),
                .LED_3(LED_3),
                .LED_4(LED_4),
                .LED_5(LED_5)
        );

        initial begin
                // Initialize Inputs
                RESETB = 0;
                RXD = 1;

                // Wait 100 ns for global reset to finish
                #100;
                RESETB = 1;
                #8680;
                RXD = 1'b0;  //start #1 "A"
                #8680;
                RXD = 1'b1;  // 1
                #8680;
                RXD = 1'b0;  // 2
                #8680;
                RXD = 1'b0;  // 3
                #8680;
                RXD = 1'b0;  // 4
                #8680;
                RXD = 1'b0;  // 5
                #8680;
                RXD = 1'b0;  // 6
                #8680;
                RXD = 1'b1;  // 7
                #8680;
                RXD = 1'b0;  // 8
                #8680;
                RXD = 1'b1;  // stop
                #8680;
                #8680;
                #8680;
                RXD = 1'b0;  //start #2
                #8680;
                RXD = 1'b1;  // 1
                #8680;
                RXD = 1'b1;  // 2
                #8680;
                RXD = 1'b1;  // 3
                #8680;
                RXD = 1'b1;  // 4
                #8680;
                RXD = 1'b0;  // 5
                #8680;
                RXD = 1'b0;  // 6
                #8680;
                RXD = 1'b0;  // 7
                #8680;
                RXD = 1'b0;  // 8
                #8680;
                RXD = 1'b1;  // stop
                #8680;
                #8680;
                #8680;
                #8680;
                RXD = 1'b0;  //start #3  CR
                #8680;
                RXD = 1'b1;  // 1
                #8680;
                RXD = 1'b0;  // 2
                #8680;
                RXD = 1'b1;  // 3
                #8680;
                RXD = 1'b1;  // 4
                #8680;
                RXD = 1'b0;  // 5
                #8680;
                RXD = 1'b0;  // 6
                #8680;
                RXD = 1'b0;  // 7
                #8680;
                RXD = 1'b0;  // 8
                #8680;
                RXD = 1'b1;  // stop
                #8680;
                #86800;
                RXD = 1'b0;  //start #4  LF
                #8680;
                RXD = 1'b0;  // 1
                #8680;
                RXD = 1'b1;  // 2
                #8680;
                RXD = 1'b0;  // 3
                #8680;
                RXD = 1'b1;  // 4
                #8680;
                RXD = 1'b0;  // 5
                #8680;
                RXD = 1'b0;  // 6
                #8680;
                RXD = 1'b0;  // 7
                #8680;
                RXD = 1'b0;  // 8
                #8680;
                RXD = 1'b1;  // stop
                #8680;
                #86800;
                RXD = 1'b0;  //start #5 "B"
                #8680;
                RXD = 1'b0;  // 1
                #8680;
                RXD = 1'b1;  // 2
                #8680;
                RXD = 1'b0;  // 3
                #8680;
                RXD = 1'b0;  // 4
                #8680;
                RXD = 1'b0;  // 5
                #8680;
                RXD = 1'b0;  // 6
                #8680;
                RXD = 1'b1;  // 7
                #8680;
                RXD = 1'b0;  // 8
                #8680;
                RXD = 1'b1;  // stop
                #8680;
                #8680;
                #8680;
                RXD = 1'b0;  //start #6
                #8680;
                RXD = 1'b1;  // 1
                #8680;
                RXD = 1'b1;  // 2
                #8680;
                RXD = 1'b1;  // 3
                #8680;
                RXD = 1'b1;  // 4
                #8680;
                RXD = 1'b0;  // 5
                #8680;
                RXD = 1'b0;  // 6
                #8680;
                RXD = 1'b0;  // 7
                #8680;
                RXD = 1'b0;  // 8
                #8680;
                RXD = 1'b1;  // stop
                #8680;
                #8680;
                #8680;
                #8680;
                RXD = 1'b0;  //start #7
                #8680;
                RXD = 1'b1;  // 1
                #8680;
                RXD = 1'b0;  // 2
                #8680;
                RXD = 1'b1;  // 3
                #8680;
                RXD = 1'b1;  // 4
                #8680;
                RXD = 1'b0;  // 5
                #8680;
                RXD = 1'b0;  // 6
                #8680;
                RXD = 1'b0;  // 7
                #8680;
                RXD = 1'b0;  // 8
                #8680;
                RXD = 1'b1;  // stop
                #8680;
                #86800;
                RXD = 1'b0;  //start #8  LF
                #8680;
                RXD = 1'b0;  // 1
                #8680;
                RXD = 1'b1;  // 2
                #8680;
                RXD = 1'b0;  // 3
                #8680;
                RXD = 1'b1;  // 4
                #8680;
                RXD = 1'b0;  // 5
                #8680;
                RXD = 1'b0;  // 6
                #8680;
                RXD = 1'b0;  // 7
                #8680;
                RXD = 1'b0;  // 8
                #8680;
                RXD = 1'b1;  // stop
                #86800;
                #86800;
                #86800;
                $stop;
        
                // Add stimulus here

        end
      
        initial begin
                // Initialize Inputs
                CLK = 0;
                repeat(500000000) begin
                #12.5;
                CLK = 1;
                #12.5;
                CLK = 0;
                end
                $stop;
        end // initial begin
   
endmodule

